%!TEX root = main.tex
\section{Mathematical Recap}

\subsection{Monomial Ordering and Leading Terms}

\begin{definition}
    (Monomial ordering)
    A monomial ordering is a relation, $> $, on the set of monomials $x^\alpha $ whereby $\alpha \in \mathbb{Z}^n_{\geq 0} $ and satisfies the following properties:
    \begin{enumerate}
        \item
              $> $ is a total ordering on $\mathbb{Z}^n_{\geq 0} $ (follows the laws of reflexivity, antisymmetry, transivity and all items being ordered must be comparable).
        \item Let $\beta \in \mathbb{Z}^n_{\geq 0}$.
              If $\alpha > \beta $ and $\gamma \in \mathbb{Z}^n_{\geq 0} $ then $\alpha + \gamma > \beta + \gamma $.
        \item $> $ is a well ordering on $\mathbb{Z}^n_{\geq 0} $.
              This essentially means that there will always be a smallest element in the set of ordered monomials.
    \end{enumerate} \cite[p.55]{Cox:2012iv}
\end{definition}

Let us define an important, yet simple notion.
Let $f$ be an arbitrary polynomial in some polynomial ring, $F_q[X]$.
We say that the leading monomial of $f $, $LM(f) $ is monomial with the largest total degree in $f$.
For example, $LM(12x_1^5x_2^2 + 5x_2^{50}) = x_2^{50} $.

\subsection{Homogeneous polynomials}

A homogeneous polynomial is a polynomial whereby all its monomials are of the same degree \cite{Bardet:2004ec}.
In the case of affine polynomials (i.e. polynomials with coefficients in an algebraically closed field $\mathbb{K}$ and have solutions in $\mathbb{K}$), we can make them homogeneous by including a homogenisation variable.

Lastly, we assume we are working with polynomials in $\mathbb{F}_q$ of degree $q$ (i.e., for $\mathbb{F}_2$, all polynomials will be of degree 2).

\subsection{Regular and semi-regular systems}
Let $\mathbb{F}_q$ be a finite field of size $q$ such that $\mathbb{F}_q[X = x_1\hdots x_n]$ is a polynomial ring over $n$ variables.
\begin{definition}
    (Regular Systems)
    A regular system is a sequence of homogeneous polynomials, denoted as $f_1,\hdots,f_m \in \mathbb{F}_q[X]$, with degrees $\deg(f_i) = d_i$, such that if $i \in \{1,\hdots,m\}$ and $g \in \mathbb{F}_q[X] $,
    \begin{equation}
        gf_i \in \braket{f_1,\hdots,f_{i-1}}
    \end{equation}
    then, $g $ is also in the ideal generated by $f_1,\hdots,f_{i-1} $.
\end{definition}
Regular systems, are at most, determined, meaning that they have, at most, $n = m $, whereby $n$ is the number of variables in the system of polynomials and $m$ is the number of equations \cite{Bardet:2005ab}.
\begin{definition}
    (Semi-Regular Systems)
    A semi-regular system with degree of regularity $d_{reg} \in \mathbb{N}$ is a homogeneous overdetermined system $(m > n)$ in $\mathbb{F}_q[X]$ with degrees $\deg(f_i) = d_i$, such that if $i \in \{1,\hdots,m\}$ and $g \in \mathbb{F}_q[X] $,
    \begin{equation}
        gf_i \in \braket{f_1,\hdots,f_{i-1}} \textrm{ and } deg(gf_i) < d_{reg}
    \end{equation}
    then, $g $ is also in the ideal generated by $f_1,\hdots,f_{i-1}$ \cite{Bardet:2005ab}.
\end{definition}
The degree of regularity and will be discussed in the following section.

\begin{definition}
    (Boolean Semi-Regular Systems in $\mathbb{F}_2$)
    Let $R_b = \mathbb{F}_2[X]/(x_1^2,\hdots,x_n^2)$.
    A system with degree of regularity $d_{reg} \in \mathbb{N}$ is a semi-regular system in $R_b$ if it is an homogeneous overdetermined system $(m > n)$ with degrees $\deg(f_i) = d_i$, such that if $i \in \{1,\hdots,m\}$ and $g_i \in \mathbb{F}_2[X]$, and,
    \begin{equation}
        \braket{f_1,\hdots,f_m} \subset R_h
    \end{equation}
    and if,
    \begin{equation}
        g_if_i = 0 \textrm{ and } deg(g_if_i) < d_{reg}
    \end{equation}
    then, $g_i = 0$ in $R_b/(f_1,\hdots,f_i)$ \cite[p.58]{Bardet:2004ec}.
\end{definition}

Note how we include the field equations $x_i^2 = 0$, which will remove all squares.
Hence, we assume that when working in $\mathbb{F}_2$, we include the field equations, which is why we refer to $\mathbb{F}_2$ as boolean.

\subsection{Degree of regularity}
Given that $q$ is a power of a prime, let $I$ be an ideal in $\mathbb{F}_q[X = x_1,\hdots,x_n]$ generated by a finite homogeneous
system of $m$ polynomials.
Denote the set of all possible polynomials in a polynomial ring $\mathbb{F}_q[X]$ with a degree at most $s$ as $\mathbb{F}_q[X]_{\leq s}$.
We also denote $I_{\leq s} $ as the set of polynomials in $I$ with degree at most $s$.

We now define the Hilbert Function of an ideal $I$ as,
\begin{definition}
    \label{def:hf}
    (Hilbert Function \cite[p.487]{Cox:2012iv})
    \begin{equation}
        HF_I(s) = \dim(\mathbb{F}_q[X]_{\leq s}) - \dim(I_{\leq s})
    \end{equation}
\end{definition}
Note that in this context, we define the dimension of the set $\mathbb{F}_q[X]_{\leq s}$ as a $\mathbb{F}_q[X]$ vector space.
Equation~\ref{def:hf} shows that the Hilbert Function is the dimension of polynomials in the polynomial ring that are not in the ideal.
This means that when the dimension of the set of polynomials with degree at most $s$ in ideal $I$ is equal to the dimension of the set of polynomials with degree less or equal to $s$ in the polynomial ring, the Hilbert Function will output 0.

Let $F = \{f_1,\hdots,f_m\}$ be a semi-regular system of equations with $n$ variables and degrees $\deg(f_i) = d_i$ whereby $f_i \in F$.
The Hilbert Series of this non-boolean (\ie{,  in $\mathbb{F}_{q>2}$}) semi-regular system of equations is the formal series,
\begin{definition}
    (Hilbert Series of a non-boolean semi-regular system of equations \cite[p.66]{Bardet:2004ec})
    \begin{equation}
        \label{eqn:hilbertfq}
        S_{m,n} = \frac{\prod^m_{i=1} (1-t^{d_i})}{(1-t)^n}
    \end{equation}
\end{definition}

For the rest of the manuscript, we define the degree of regularity of a non-boolean semi-regular system of equations as the power of the first non-negative coefficient of the series in Equation~\ref{eqn:hilbertfq}.
Despite experimental evidence that semi-regular sequences are common, the problem lies on assessing the existence of such sequences \cite{Hodges:2014ex}.

Let $F = \{f_1,\hdots,f_m\}$ be a semi-regular system of equations with $n$ variables and degrees $\deg(f_i) = d_i$ whereby $f_i \in F$.
Note that $d_i \leq 2$.
The Hilbert Series of this boolean (\ie{,  in $\mathbb{F}_2$}) semi-regular system of equations is formal series,
\begin{definition}
    (Hilbert Series of a boolean semi-regular system  of equations \cite[p.68]{Bardet:2004ec})
    \begin{equation}
        \label{eqn:hilbertf2}
        S_{m,n} = \frac{(1+t)^n}{\prod^m_{i=1} (1+t^{d_i})}
    \end{equation}
\end{definition}

For the rest of the manuscript, we define the degree of regularity of a boolean semi-regular system of equations, as the power of the first non-negative coefficient of the series in Equation~\ref{eqn:hilbertf2}.

\subsection{Macaulay matrix}
Consider an ideal $I = \braket{f_1,\hdots,f_m} \in \mathbb{F}_q[X] $.
Let $F \in \mathbb{F}_q[X]$ be a polynomial system of equations whereby the degree of each $f_i \in F$ is denoted as $d_i$.
\begin{definition}
    (Macaulay Matrix of degree $D$)
    We define a Macaulay Matrix, $Mac_{D}(f)$ (or $Mac_D$ for short), of degree $D$ as a coefficient matrix of the set $\{u\cdot f_i \, \vert \, \textrm{deg}(u) \leq D - d_i\}$ whereby $i \in \{1,\hdots,m\}$ and $u$ is a monomial in $\mathbb{F}_q[X]$ and $f_i \in F$.
\end{definition}

Another way of putting it is that a Macaulay Matrix of degree $D$ is a coefficient matrix whose columns lists all monomials with degrees at most $D$ from largest till smallest, as per some fixed ordering.
We then multiply each $f_i$ by all monomials of degree at most $D-d_i $,  whereby $d_i$ is the degree of $f_i $.
Each row of the Macaulay Matrix is indexed by the result of these multiplications.

\cite{Lazard:1983gb} proved that there exists a positive integer $D$ whereby the rows of a row reduced Macaulay Matrix of degree $D$ are a Gr\"obner Basis for the ideal $\braket{f_1,\hdots,f_m} $.
Hence, we can use Macaulay Matrices to aid us to solve polynomial systems of equations.

At times, when it is important to mention the number of equations and degrees in the system of equations generating ideal $I$, we denote the Macaulay Matrix as $Mac^{m,d_f}_{D}$ for $d_f = (d_1,\hdots,d_m)$, whereby each $d_i \in d_f$ is the degree of $f_i$.
For homogeneous systems, we omit the $d_f$ from the notation as all values in $d_f$ are the identical.

\subsection{General and Frobenius Criteria}

In many algorithms that utilise Macaulay Matrices for computing the Gr\"obner Basis of a system of equations, some rows of the Macaulay Matrix are removed if they conform to some criteria.

The first criteria will remove any lines that will result in the trivial reduction $f^2 \rightarrow 0$ due to the field equations $x_i^2 = 0$.

\begin{definition}
    (Frobenius Criteria \cite[Proposition 1.5.2]{Bardet:2004ec})
    In boolean homogeneous system of equations, $f$, if the row corresponding to $(u,f_m)$ in the Macaulay Matrix $Mac^{m}_{D-2}$ has leading term $t$, then the row $(t,f_m)$ in $Mac^{m}_D$ is a linearly dependent on the rows preceding it.
\end{definition}

The second criteria will remove any lines that will result in the trivial reduction $f_if_j = f_jf_i$ (and hence $f_if_j - f_jf_i = 0$) for $i neq j$ due to the field equations $x_i^2 = 0$.

\begin{definition}
    (General Criteria \cite[Proposition 1.5.1]{Bardet:2004ec} \cite{Faugere:2002f5})
    In system of potentially non-homogeneous equations, $f$, then for all $j < m $,  if the row corresponding to $(u,f_m)$ in the Macaulay Matrix $Mac^{m-1,d_f}_{D-d_m}$ with leading term $t$, then the row $(t,f_m)$ in $Mac^{m}_D$ is a linearly dependent on the rows preceding it.
\end{definition}

\subsubsection{Relationship with the degree of regularity}
\label{sec:relationdegreg}
According to \cite[p.65-66]{Bardet:2004ec}, we can make a 1-to-1 correspondence between the Hilbert Function and a Macaulay Matrix for homogeneous semi-regular systems of equations.
This is done by setting $\dim(\mathbb{F}_q[X]_{\leq s})$ as the number of columns of the Macaulay Matrix and $\dim(I_{\leq s})$ as the number of linearly independent rows (rank) of the Macaulay Matrix.
Hence, another definition for the degree of regularity of a semi-regular polynomial system of equations with $n$ variables and $m$ equations is the smallest degree $D$ whereby its Macaulay Matrix of this degree has as many (or more) linearly independent rows as columns.
Because of this, it is possible to obtain linear equations (or low degree equations) from computing this Macaulay Matrix's row echelon form.
It was first noted by \cite{Lazard:1983gb} that Gaussian Elimination of a degree $D = d_{reg}$ Macaulay Matrix is equivalent to performing the Buchberger Algorithm which outputs a Gr\"obner Basis.

Lastly, there exists a very close relationship between the corank of a Macaulay Matrix and the Hilbert Function for homogeneous semi-regular systems of equations.
If we recall, we define the Hilbert Function as,
\begin{equation*}
    HF_I(s) = \dim(\mathbb{F}_q[X]_{\leq s}) - \dim(I_{\leq s})
\end{equation*}
which, according to the aforementioned relationship between a Macaulay Matrix and the Hilbert Function, is the number of columns of the Macaulay Matrix minus its linearly independent rows (its rank).
This is, by definition, the corank of a Macaulay Matrix

